//
//  main.m
//  RandomPoessessions
//
//  Created by Benjamin Tan on 16/2/13.
//  Copyright (c) 2013 Benjamin Tan. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BNRItem.h"

int main(int argc, const char * argv[])
{

    @autoreleasepool {
        // Create a mutable array object, store its address in items variable
        NSMutableArray *items = [[NSMutableArray alloc] init];
        
        // Send the message addObject: to the NSMutableArray pointed to
        // by the variable items, passing a string each time.
        [items addObject:@"One"];
        [items addObject:@"Two"];
        [items addObject:@"Three"];
        
        // Send another message, insertObject:atIndex:, to that same array object
        [items insertObject:@"Zero" atIndex:0];
        
        // For every item in the array as determined by sending count to items
        for (int i = 0; i < [items count]; i++) {
            // We get the ith object from the array and pass it as an argument to
            // NSLog, which implicitly sends the description message to that object
            NSLog(@"%@", [items objectAtIndex:i]);
        }
        
        BNRItem *p = [[BNRItem alloc] init];
        
        [p setItemName:@"Red Sofa"];
        [p setSerialNumber:@"A1B2C3"];
        [p setValueInDollars:100];
        
        NSLog(@"%@", p);
        
        BNRItem *q = [[BNRItem alloc] initWithItemName:@"Pink Sofa"
                                        valueInDollars:123
                                          serialNumber:@"D4E5F6"];
        
        NSLog(@"%@", q);

        
        for (int i = 0; i < 100; i++) {
            BNRItem *p = [BNRItem randomItem];
            [items addObject:p];
        }
        
        for (int i = 0; i < [items count]; i++) {
            NSLog(@"%@", [items objectAtIndex:i]);
        }
        
        // Fast enumeration
        for (BNRItem *item in items) {
            NSLog(@"%@", item);
        }
        
        // Destroy the array pointed to by items
        items = nil;
    }
    return 0;
}

