//
//  WhereamiViewController.m
//  Whereami
//
//  Created by Benjamin Tan on 17/2/13.
//  Copyright (c) 2013 Benjamin Tan. All rights reserved.
//

#import "WhereamiViewController.h"

@implementation WhereamiViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    
    if (self) {
        // Create the location manager object
        locationManager = [[CLLocationManager alloc] init];
        
        // There will be a warning for this line of code, but ignore it for now.
        [locationManager setDelegate:self];
        
        // And we want to set it as accurate as possible
        // regardless of how much time/power it takes
        [locationManager setDesiredAccuracy:kCLLocationAccuracyBest];
        
        // Tell our manager to start looking for its location immediately
        [locationManager startUpdatingLocation];
    }
    return self;
}

- (void)locationManager:(CLLocationManager *)manager
    didUpdateToLocation:(CLLocation *)newLocation
           fromLocation:(CLLocation *)oldLocation
{
    NSLog(@"%@", newLocation);
}

- (void)locationManager:(CLLocationManager *)manager
       didFailWithError:(NSError *)error
{
    NSLog(@"Could not find location: %@", error);

}

// We have to manually override this, since the `delegate` reference
// is neither strong nor weak. Its __unsafe_unretained.
- (void)dealloc
{
    // Tell the location manager to stop sending us messages.
    [locationManager setDelegate:nil];
}

@end
