class WhereamiController < UIViewController
  def initWithNibName(nib_name, bundle: bundle)
    result = super
    if result
      location_manager = CLLocationManager.alloc.init
      location_manager.setDelegate(self)
      location_manager.setDesiredAccuracy(KCLLocationAccuracyBest)
      location_manager.startUpdatingLocation

      @world_view = MKMapView.alloc.init.tap do |w|
        w.mapType           = MKMapTypeStandard
        w.delegate          = self
        w.showsUserLocation = true
        w.frame             = UIScreen.mainScreen.bounds
        view.addSubview(w)
      end

      @activity_indicator = UIActivityIndicatorView.alloc.init.tap do |ai|
        ai.activityIndicatorViewStyle = UIActivityIndicatorViewStyleWhiteLarge
        ai.frame                      = [[view.bounds.size.width/2-13, 30], [26,26]]
        ai.hidesWhenStopped           = true
        view.addSubview(ai)
      end

      @location_text_field = UITextField.alloc.init.tap do |tf|
        margin         = 40
        tf.frame       =  [[36, 20], [248, 30]]
        tf.placeholder = "Enter Location Name:"
        tf.borderStyle = UITextBorderStyleRoundedRect
        tf.delegate    = self
        view.addSubview(tf)
      end
    end
    result
  end

  def locationManager(manager, didUpdateToLocation:new_location, fromLocation:old_location)
    puts "#{new_location}"
  end

  def locationManager(manager, didFailWithError: error)
    puts "Failed to find location: #{error}"
  end
end