//
//  HypnosisterAppDelegate.m
//  Hypnosister
//
//  Created by Benjamin Tan on 20/2/13.
//  Copyright (c) 2013 Benjamin Tan. All rights reserved.
//

#import "HypnosisterAppDelegate.h"
#import "HypnosisterView.h"

@implementation HypnosisterAppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    
    [[UIApplication sharedApplication] setStatusBarHidden:YES
                                            withAnimation:UIStatusBarAnimationFade];
    
    //--- Override point for customization after application launch. ---
    
    CGRect screenRect =[[self window] bounds];
    
    // Create the UISCrollView to have the size of the window, matching its size
    UIScrollView *scrollview = [[UIScrollView alloc] initWithFrame:screenRect];
    [[self window] addSubview:scrollview];
    
    // Create the HypnosisView with a frame that is twice the swize of the screen
    CGRect bigRect = screenRect;
    view = [[HypnosisterView alloc] initWithFrame:screenRect];
    
    // Add the HypnosisView as a subview of the scrollView instead of the window
    [scrollview addSubview:view];
    
    // Tell the scrollview how big its virtual world would be
    [scrollview setContentSize:bigRect.size];
    // [scrollview setPagingEnabled:YES];
    
    [scrollview setMinimumZoomScale:1.0];
    [scrollview setMaximumZoomScale:50.0];
    
    // You will get a warning here, ignore it for now
    [scrollview setDelegate:self];
    
    // Add a cross to view
    
    UIView *lineView = [[UIView alloc] initWithFrame:CGRectMake(0, 20, 20, 1)];

    
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    CGContextMoveToPoint(ctx, view.center.x - 10, view.center.y);
    CGContextAddLineToPoint(ctx, view.center.x + 20, view.center.y);
    
    CGContextMoveToPoint(ctx, view.center.x, view.center.y - 10);
    CGContextAddLineToPoint(ctx, view.center.x + 20, view.center.y + 20);

    CGContextStrokePath(ctx);

    // We create a cross first.
    
    
    
    BOOL success = [view becomeFirstResponder];
    if (success) {
        NSLog(@"HypnosisView became the first responder");
    } else {
        NSLog(@"Could not become the first responder");
    }
    
    self.window.backgroundColor = [UIColor whiteColor];
    [self.window makeKeyAndVisible];
    return YES;
}


- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView
{
    return view;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}
@end